import 'dart:io';

import 'package:qz_log/src/model/qz_log_model.dart';
import 'package:qz_log/src/repository/permission_repository.dart';
import 'package:qz_log/src/repository/qz_log_repository.dart';

class QzLog {
  static Future<void> deleteAll() async {
    try {
      await QzLogRepository.deleteAll();
    } catch (e) {
      rethrow;
    }
  }

  static Future<void> deleteLogFromDatabase() async {
    try {
      await QzLogRepository.deleteLogFromDatabase();
    } catch (e) {
      rethrow;
    }
  }

  static Future<void> deleteAllFiles() async {
    try {
      await QzLogRepository.deleteAllFiles();
    } catch (e) {
      rethrow;
    }
  }

  static Future<void> insertLog({
    required String log,
    String? exception,
  }) async {
    try {
      await QzLogRepository.insertLog(
        log: log,
        exception: exception,
      );
    } catch (e) {
      rethrow;
    }
  }

  static Future<List<QzLogModel>> getAllLogs() async {
    try {
      return await QzLogRepository.getAllLogs();
    } catch (e) {
      rethrow;
    }
  }

  static Future<bool> logExists() async {
    try {
      return await QzLogRepository.logExists();
    } catch (e) {
      rethrow;
    }
  }

  static Future<File?> exportLogs() async {
    try {
      return await QzLogRepository.exportLogs();
    } catch (e) {
      rethrow;
    }
  }

  static Future<void> checkAndRequestPermission() async {
    try {
      return await PermissionRepository.checkAndRequestPermission();
    } catch (e) {
      rethrow;
    }
  }
}
